Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 1516188 - Enabling rc-local.service fails
Summary: Enabling rc-local.service fails
Keywords:
Status: CLOSED EOL
Alias: None
Product: Fedora
Classification: Fedora
Component: systemd
Version: 27
Hardware: x86_64
OS: Linux
unspecified
medium
Target Milestone: ---
Assignee: systemd-maint
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2017-11-22 08:53 UTC by k.c.harke
Modified: 2018-11-30 22:46 UTC (History)
7 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2018-11-30 22:46:59 UTC


Attachments (Terms of Use)

Description k.c.harke 2017-11-22 08:53:51 UTC
Description of problem:
systemctl enable rc-local.service does not start the service. Workaround/solution (?): Modify /usr/lib/systemd/system/rc-local.service

Version-Release number of selected component (if applicable):


How reproducible:


Steps to Reproduce:
1. Generate an executable /etc/rc.d/rc.local (#!/bin/bash ... exit 0)
2. sudo systemctl enable rc-local.service
3.

Actual results:
systemctl says:
The unit files have no installation config (WantedBy, RequiredBy, Also, Alias
settings in the [Install] section, and DefaultInstance for template units).
This means they are not meant to be enabled using systemctl.
Possible reasons for having this kind of units are:
1) A unit may be statically enabled by being symlinked from another unit's
   .wants/ or .requires/ directory.
2) A unit's purpose may be to act as a helper for some other unit which has
   a requirement dependency on it.
3) A unit may be started when needed via activation (socket, path, timer,
   D-Bus, udev, scripted systemctl call, ...).
4) In case of template units, the unit is meant to be enabled with some
   instance name specified.


Expected results:
rc-local.service should start on boot and execute /etc/rc.d/rc.local

Additional info:
Adding following at the end of the file
/usr/lib/systemd/system/rc-local.service
seems to solve the problem:

[Install]
WantedBy=multi.user.target

Context: I wanted to change the power-setting of external USB-devices (mouse, keyboard to 'on' after start of powertop.service. With the modification of /usr/lib/systemd/system/rc-local.service the service ist started successfully, but nevertheless the commands in /etc/rc.d/rc.local have no effect, grmpfz.

Comment 1 Lukáš Nykrýn 2017-11-22 10:56:22 UTC
rc-local.service is not meant to be enabled manually. There is a generator that enables automatically when proper conditions are met.
https://github.com/systemd/systemd/blob/master/src/rc-local-generator/rc-local-generator.c

Comment 2 Lonni J Friedman 2018-10-14 17:16:32 UTC
Also seeing this bug.  Its unclear to me what 'proper conditions' need to be met to make this work.  My /etc/rc.local has executable perms.  What more is needed?

Comment 3 Ben Cotton 2018-11-27 14:01:34 UTC
This message is a reminder that Fedora 27 is nearing its end of life.
On 2018-Nov-30  Fedora will stop maintaining and issuing updates for
Fedora 27. It is Fedora's policy to close all bug reports from releases
that are no longer maintained. At that time this bug will be closed as
EOL if it remains open with a Fedora  'version' of '27'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 27 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 4 Zbigniew Jędrzejewski-Szmek 2018-11-27 14:11:47 UTC
This should work. It seems to work here. Please run

mkdir -p /tmp/x && SYSTEMD_LOG_LEVEL=debug strace -eaccess /usr/lib/systemd/system-generators/systemd-rc-local-generator /tmp/{x,x,x}

You should see something like:
...
access("/etc/rc.local", X_OK)           = 0
Automatically adding rc-local.service.
access("/usr/sbin/halt.local", X_OK)    = -1 ENOENT (No such file or directory)
+++ exited with 0 +++

Comment 5 Zbigniew Jędrzejewski-Szmek 2018-11-27 14:27:20 UTC
https://github.com/systemd/systemd/pull/10955 makes the generator a bit more verbose.

Comment 6 Ben Cotton 2018-11-30 22:46:59 UTC
Fedora 27 changed to end-of-life (EOL) status on 2018-11-30. Fedora 27 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.